Zavrsni/urls.py
from django.contrib import admin
from django.urls import path
from django.conf.urls import include
from django.conf import settings
from django.conf.urls.static import static

urlpatterns = [
    path('admin/', admin.site.urls),
    path('users/', include('users.urls')),
    path('comm/', include('common.urls')),
    path('unis/', include('unis.urls')),
    path('relations/', include('relations.urls')),
    path('', include('posts.urls')),
] + static(settings.STATIC_URL, document_root=settings.STATIC_ROOT)
urlpatterns += static(settings.MEDIA_URL, document_root= settings.MEDIA_ROOT)

relations/urls.py
from django.urls import path
from relations.views import RelationListVieW

urlpatterns = [
      path('relations/', RelationListVieW.as_view(), name="relation-list"),
]

unis/urls.py
from django.urls import path
from unis.views import CroUniListVieW, ExUniListVieW, ExUniDetailView, CroUniDetailView, CroUniListVieWSecond

urlpatterns = [
    path('exunis/', ExUniListVieW.as_view(), name="ex-list"),
    path('crounis/', CroUniListVieW.as_view(template_name='unis/crounis1.html'), name="cro-list"),
    path('crounis2/<int:pk>', CroUniListVieWSecond.as_view(template_name='unis/crounis.html'), name="cro-list2"),
    path('exunis/<int:pk>/', ExUniDetailView.as_view(), name="exuni-detail"),
    path('crounis/<int:pk>/', CroUniDetailView.as_view(), name="crouni-detail"),
]

posts/models.py
from django.db import models
from users.models import CustomUser
from django.urls import reverse
from relations.models import Relation
from unis.models import ExUni
from common.models import City, FinanceType
from PIL import Image
from django.core.validators import MaxValueValidator, MinValueValidator


class Post(models.Model):
    author = models.OneToOneField(CustomUser, on_delete=models.SET_NULL, null=True, blank=True)
    relation = models.ForeignKey(Relation, on_delete=models.SET_NULL, null=True, blank=True)

    title = models.CharField(max_length=100, default="")
    ex_year = models.IntegerField(default=2019, blank=False, validators=[
            MinValueValidator(1975),
            MaxValueValidator(2019)
        ])
    generally = models.TextField(blank=True, null=True)
    last_modified = models.DateTimeField('date_published', auto_now=True)

    def __str__(self):
        return self.title

    def get_absolute_url(self):
        return reverse('post-detail', kwargs={'pk': self.pk})

class AboutCity(models.Model):
    city = models.ForeignKey(City, on_delete=models.CASCADE, null=True)
    post = models.OneToOneField(Post, on_delete=models.CASCADE, null=True)

    places_to_see = models.TextField(blank=True, null=True)
    city_traffic = models.TextField(blank=True, null=True)
    how_to_arrive = models.TextField(blank=True, null=True)
    where_to_go = models.TextField(blank=True, null=True)
    food = models.TextField(blank=True, null=True)

    def __str__(self):
        return self.city.name

    def get_absolute_url(self):
        return reverse('post-detail', kwargs={'pk': self.post.pk})

class AboutUni(models.Model):
    ex_uni = models.ForeignKey(ExUni, on_delete=models.CASCADE, null=True)
    post = models.OneToOneField(Post, on_delete=models.CASCADE, null=True)

    generally = models.TextField(blank=True, null=True)
    prof = models.TextField(blank=True, null=True)
    subjects = models.TextField(blank=True, null=True)

    def get_absolute_url(self):
        return reverse('post-detail', kwargs={'pk': self.post.pk})

    def __str__(self):
        return self.ex_uni.name

class Media(models.Model):
    post = models.ForeignKey(Post, null=True, blank=True, on_delete=models.CASCADE)

    myimage = models.FileField(upload_to='images/', null=True, verbose_name="")

    def __str__(self):
        return str(self.myimage)

    #resize
    def save(self, *args, **kwargs):
        super().save(*args, **kwargs)
        img = Image.open(self.myimage.path)

        if img.height > 700 or img.width > 700:
            output_size = (700, 700)
            img.thumbnail(output_size)
            img.save(self.myimage.path)



class Finance(models.Model):
    finance_type = models.ForeignKey(FinanceType, on_delete=models.CASCADE)
    post = models.ForeignKey(Post, on_delete=models.CASCADE)
    amount = models.PositiveIntegerField(default=0)
    ordering = ['amount']

    def __str__(self):
        return self.finance_type.__str__() + "-" + self.amount.__str__()

    def get_absolute_url(self):
        return reverse('finance-list', kwargs={'pk': self.post.pk})

    class Meta:
        unique_together = (("finance_type", 'post'),)

relations/models.py
from django.db import models
from unis.models import CroUni, ExUni

class ISCEDArea(models.Model):
    isced_id = models.CharField(max_length=100)
    isced_name = models.CharField(max_length=100)

    def __str__(self):
        return self.isced_id

class Programme(models.Model):
    name = models.CharField(max_length=300)
    short_name = models.CharField(max_length=100, default="sms")

    def __str__(self):
        return self.short_name


class Relation(models.Model):
    cro_uni = models.ForeignKey(CroUni, on_delete=models.DO_NOTHING)
    ex_uni = models.ForeignKey(ExUni, on_delete=models.DO_NOTHING)
    ISCED_Area = models.ForeignKey(ISCEDArea, on_delete=models.DO_NOTHING)
    program = models.ForeignKey(Programme, on_delete=models.DO_NOTHING)

    bachelor = models.BooleanField(default=False)
    master = models.BooleanField(default=False)
    doctorate = models.BooleanField(default=False)
    duration_in_months = models.IntegerField()

    def __str__(self):
        return self.cro_uni.name+str("-")+self.ex_uni.name + str("-") + "(" + self.ISCED_Area.isced_id+")"+ self.program.short_name

    class Meta:
        ordering = ('program', 'cro_uni', 'ex_uni', 'duration_in_months')

relations/views.py
from django.shortcuts import render
from django.views.generic import ListView
from .filters import RelationFilter
from .models import Relation


class RelationListVieW(ListView):
    model = Relation
    template_name = 'relations/relations.html'

    def get_context_data(self, **kwargs):
        context = super().get_context_data(**kwargs)
        context['filter'] = RelationFilter(self.request.GET, queryset=self.get_queryset())
        return context


def relation_view(request):
    query = request.GET.get("q", None)
    qs = Relation.objects.all()
    if query is not None:
        qs = qs.filter(program__name__icontains=query)
    context = {
        "object_list": qs
    }
    template = "relations/relations.html"
    return render(request, template, context)

relations/templates/relations/relations.html
{% extends "posts/base.html"%}
{% block page_content %}
<font color="black">

<div id="page" class="container">
<section>
    <header class="major">
        <h2>Relations</h2>
        <span class="byline">This is table of every possible exchange</span>
    </header>

        <form method="GET">
           <table>
               <tr>
                  <th><p>Exchange university: <br>{{ filter.form.ex_uni }}</p></th>
                   <th><p>Program : <br>{{ filter.form.program }}</p></th>
                   <tr/>
                   <tr>
                   <th><p>Croatian university: <br>{{ filter.form.cro_uni }}</p></th>
                   <th><p>ISCED area : <br>{{ filter.form.ISCED_Area }}</p>  </th>

               </tr>

               <tr>
                   <th><p>Bachelor :  <br>{{ filter.form.bachelor }}</p>  </th>
                   <th><p>Master : <br>{{ filter.form.master }}</p></th>
               </tr><tr>
                   <th><p>Doctorate : <br> {{ filter.form.doctorate }}</p>  </th>
                   <th><p>Duration(months) : <br> {{ filter.form.duration_in_months }}</p></th>
               </tr>
               </table>
       <p><button type="submit" class="button">Search</button></p>
        </form>
    <table>
        <tr>
            <th><p><b>CROuni</b></p></th>
            <th><b>EXCHANGEuni</b></th>
            <th><b>ISCED</b></th>
            <th><b>PROGRAM</b></th>
            <th><b>Cycles</b></th>
            <th><b>Duration<br>(months)</b></th>
            <th><b>Reviews</b></th>
        </tr>
        {% for snippet in filter.qs %}
            <tr>
            <th><p>{{ snippet.cro_uni }}</p></th>
            <th><p>{{ snippet.ex_uni }}</p></th>
            <th><p>{{ snippet.ISCED_Area.isced_id }} - {{ snippet.ISCED_Area.isced_name }}</p></th>
            <th><p>{{ snippet.program.short_name }}</p></th>
            <th><p>{% if  snippet.bachelor %} Bachelor {% endif %}
                 {% if snippet.master %} Master {% endif %}
                 {% if snippet.doctorate %} Doctorate {% endif %}
            <th><p>{{ snippet.duration_in_months }}</p></th>
            <th>
                {% if snippet.ex_uni.aboutuni_set.count > 0 %}
                    <a href="{% url 'exuni-detail' snippet.ex_uni.id %}">University</a>
                {% endif %}
                <br>
                {% if snippet.ex_uni.city.aboutcity_set.count > 0 %}
                    <a href="{% url 'city-detail' snippet.ex_uni.city.id %}">City</a>
                {% endif %}
            </th>
            </tr>
        {% endfor %}
        </table>


</section>
</div>
</font>
{% endblock page_content %}